// GenkeyDlg.h: CGenkeyDlg NX̃C^[tFCX
//
// Copyright (C) 2006 Kazuyoshi Kakihara
//
// This file is part of JanusLeaf.
//
// JanusLeaf is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GENKEYDLG_H__03DDD571_F26C_47A7_A71A_94A6987E5AB3__INCLUDED_)
#define AFX_GENKEYDLG_H__03DDD571_F26C_47A7_A71A_94A6987E5AB3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

typedef struct {
  HWND hWnd;
  HANDLE hRead;
} GENKEY_THREAD_PARAM, *LPGENKEY_THREAD_PARAM;

class CGenkeyDlg : public CDialogImpl<CGenkeyDlg>, ioutil  
{
  CGpgParam *pm_gpg;
  BOOL fKeyGen;
public:
#ifdef USE_PASSPHRASE
  enum { IDD = IDD_KEYGEN1 };
#else
  enum { IDD = IDD_KEYGEN };
#endif
  // bZ[W}bv
  BEGIN_MSG_MAP_EX(CGenkeyDlg)
    MSG_WM_INITDIALOG(OnInitDialog)
    COMMAND_ID_HANDLER_EX(IDOK, OnOK)
    COMMAND_ID_HANDLER_EX(IDCANCEL, OnCancel)
  END_MSG_MAP()
/*
  static DWORD WINAPI procGt(LPVOID lpparam)
  {
    LPGENKEY_THREAD_PARAM ptp = reinterpret_cast<LPGENKEY_THREAD_PARAM>(lpparam);
    CHAR c;
    DWORD dwRead;
    while (::ReadFile(ptp->hRead, &c, 1, &dwRead, NULL)) {
      ::PostMessage(ptp->hWnd, WM_CHAR, static_cast<WPARAM>(c), 0);
    }
    ::CloseHandle(ptp->hRead);
    return 0;
  }
*/
  LRESULT OnInitDialog(HWND hWnd, LPARAM lParam) {
    CenterWindow();
    pm_gpg = reinterpret_cast<CGpgParam *>(lParam);

    ::EnableWindow(GetDlgItem(IDC_EDIT_NAME), TRUE);
    ::EnableWindow(GetDlgItem(IDC_EDIT_EMAIL), TRUE);
    ::EnableWindow(GetDlgItem(IDC_EDIT_COMMENT), TRUE);
#ifdef USE_PASSPHRASE
    ::EnableWindow(GetDlgItem(IDC_EDIT_PASSPHRASE), TRUE);
    ::EnableWindow(GetDlgItem(IDC_EDIT_PASSPHRASE2), TRUE);
#endif
    ::EnableWindow(GetDlgItem(IDOK), TRUE);
    ::EnableWindow(GetDlgItem(IDCANCEL), TRUE);
    ::EnableWindow(GetDlgItem(IDC_EDIT_MESSAGE), TRUE);
    ::SendMessage(GetDlgItem(IDC_EDIT_MESSAGE), EM_SETREADONLY, static_cast<WPARAM>(TRUE), 0L);
    // eRg[͕̓
    ::SendMessage(GetDlgItem(IDC_EDIT_NAME), EM_LIMITTEXT, MAX_PATH, 0);
    ::SendMessage(GetDlgItem(IDC_EDIT_EMAIL), EM_LIMITTEXT, MAX_PATH, 0);
    ::SendMessage(GetDlgItem(IDC_EDIT_COMMENT), EM_LIMITTEXT, MAX_PATH, 0);
#ifdef USE_PASSPHRASE
    ::SendMessage(GetDlgItem(IDC_EDIT_PASSPHRASE), EM_LIMITTEXT, MAX_PATH, 0);
    ::SendMessage(GetDlgItem(IDC_EDIT_PASSPHRASE2), EM_LIMITTEXT, MAX_PATH, 0);
#endif
    // For Debug
#ifdef _DEBUG
    ::SetWindowText(GetDlgItem(IDC_EDIT_NAME), "Sample User");
    ::SetWindowText(GetDlgItem(IDC_EDIT_EMAIL), "sampleuser@example.com");
    ::SetWindowText(GetDlgItem(IDC_EDIT_COMMENT), "sample");
#ifdef USE_PASSPHRASE
    ::SetWindowText(GetDlgItem(IDC_EDIT_PASSPHRASE), "passphrase");
    ::SetWindowText(GetDlgItem(IDC_EDIT_PASSPHRASE2), "passphrase");
#endif
#endif
    fKeyGen = FALSE;
    return TRUE;
  }

  void OnOK(UINT uNotifyCode, int nID, HWND hWndCtl) {
    HRESULT hr = S_OK;

    if (fKeyGen) {
      EndDialog(IDOK);
      return;
    }

    gpg g(pm_gpg->gpgexe.c_str(), pm_gpg->homedir.c_str());
    CHAR buff[MAX_PATH + 1];
    std::string name;
    std::string email;
    std::string comment;
#ifdef USE_PASSPHRASE
    std::string passphrase;
    std::string passphrase2;
#endif

    ::SetWindowText(GetDlgItem(IDC_EDIT_MESSAGE), "");
    GetDlgItemText(IDC_EDIT_NAME, buff, MAX_PATH);
    sjis2utf8(buff, name);
    if (name.length() > 0) {
      if (FAILED(g.validateName(name.c_str()))) {
        ::SetWindowText(GetDlgItem(IDC_EDIT_MESSAGE), "Ǒ`ɃG[܂");
        return;
      }
    }
    GetDlgItemText(IDC_EDIT_EMAIL, buff, MAX_PATH);
    email = buff;
    if (email.length() > 0) {
      if (FAILED(g.validateEMail(email.c_str()))) {
        ::SetWindowText(GetDlgItem(IDC_EDIT_MESSAGE), "[AhX̌`ɃG[܂");
        return;
      }
    }
    GetDlgItemText(IDC_EDIT_COMMENT, buff, MAX_PATH);
    sjis2utf8(buff, comment);
    if (comment.length() > 0) {
      if (FAILED(g.validateComment(comment.c_str()))) {
        ::SetWindowText(GetDlgItem(IDC_EDIT_MESSAGE), "Rǧ`ɃG[܂");
        return;
      }
    }
#ifdef USE_PASSPHRASE
    GetDlgItemText(IDC_EDIT_PASSPHRASE, buff, MAX_PATH);
    passphrase = buff;
    GetDlgItemText(IDC_EDIT_PASSPHRASE2, buff, MAX_PATH);
    passphrase2 = buff;
    if (passphrase != passphrase2) {
      ::SetWindowText(GetDlgItem(IDC_EDIT_MESSAGE), "pXt[Yv܂");
      return;
    }
#endif

    HANDLE hRead = INVALID_HANDLE_VALUE, hWrite = INVALID_HANDLE_VALUE;
    if (FAILED(hr = createReadPipe(&hRead, &hWrite))) {
      DEBUGOUT(hr);
      return;
    }
//    g.setStdErr(hWrite); hWrite = INVALID_HANDLE_VALUE;
    ::EnableWindow(GetDlgItem(IDC_EDIT_NAME), FALSE);
    ::EnableWindow(GetDlgItem(IDC_EDIT_EMAIL), FALSE);
    ::EnableWindow(GetDlgItem(IDC_EDIT_COMMENT), FALSE);
    ::EnableWindow(GetDlgItem(IDC_EDIT_PASSPHRASE), FALSE);
    ::EnableWindow(GetDlgItem(IDC_EDIT_PASSPHRASE2), FALSE);
    ::EnableWindow(GetDlgItem(IDOK), FALSE);
    ::EnableWindow(GetDlgItem(IDCANCEL), FALSE);
    ::EnableWindow(GetDlgItem(IDC_EDIT_MESSAGE), TRUE);
    ::SendMessage(GetDlgItem(IDC_EDIT_MESSAGE), EM_SETREADONLY, static_cast<WPARAM>(FALSE), 0L);

    HCURSOR hCursor = ::SetCursor(::LoadCursor(NULL, IDC_WAIT));
    std::string seckey = *(pm_gpg->secring.begin());
    std::string pubkey = *(pm_gpg->pubring.begin());
#ifdef USE_PASSPHRASE
    hr = g.genkey(seckey.c_str(),
                  pubkey.c_str(),
                  name.empty() ? NULL : name.c_str(),
                  email.empty() ? NULL : email.c_str(),
                  comment.empty() ? NULL : comment.c_str(),
                  passphrase.empty() ? NULL : passphrase.c_str(),
                  hWrite);
#else
    hr = g.genkey(seckey.c_str(),
                  pubkey.c_str(),
                  name.empty() ? NULL : name.c_str(),
                  email.empty() ? NULL : email.c_str(),
                  comment.empty() ? NULL : comment.c_str(),
                  NULL,
                  hWrite);
#endif
    hWrite = INVALID_HANDLE_VALUE;
    if (SUCCEEDED(hr)) {
      std::string str;
      std::string str2;
      DWORD dwRead;
      BOOL bP = FALSE;
      HWND hwnd = GetDlgItem(IDC_EDIT_MESSAGE);
      while (SUCCEEDED(read(hRead, str, &dwRead))) {
        if (dwRead == 0) break;
        if (str.substr(0, 18) == "[GNUPG:] PROGRESS ") {
          LPCSTR p = str.c_str() + 18;
          while (*p != ' ') ++p;
          while (*p == ' ') ++p;
          ::SendMessage(hwnd, WM_CHAR, static_cast<WPARAM>(*p), 0);
          bP = TRUE;
        } else {
//        g.utf82sjis(str.c_str(), str2);
          LPCSTR p = str.c_str();
          int imax = str.length();
          if (bP) ::SendMessage(hwnd, WM_CHAR, static_cast<WPARAM>('\n'), 0);
          bP = FALSE;
          for (int i = 0; i < imax; ++i) {
            if (IsDBCSLeadByte(*(p + i))) {
              ::SendMessage(hwnd, WM_IME_CHAR, static_cast<WPARAM>(*(p + i) << 8 | *(p + i + 1)), 1);
              ++i;
            } else {
              ::SendMessage(hwnd, WM_CHAR, static_cast<WPARAM>(*(p + i)), 0);
            }
          }
          ::SendMessage(hwnd, WM_CHAR, static_cast<WPARAM>('\n'), 0);
        }
      }
      ::CloseHandle(hRead);
      hRead = INVALID_HANDLE_VALUE;
      DWORD dwExitCode;
      g.close(&dwExitCode);
      ::SetCursor(hCursor);
      ::SendMessage(GetDlgItem(IDC_EDIT_MESSAGE), EM_SETREADONLY, static_cast<WPARAM>(TRUE), 0L);
      ::EnableWindow(GetDlgItem(IDOK), TRUE);
      fKeyGen = TRUE;
      // dwExitCode̒ľ؂͂AMessageBox̒g[U[ɓǂ܂邱ƂőΏƂ
      return;
    } else {
      ::SetCursor(hCursor);
      DEBUGOUT(hr);
      MessageBox("̐Ɏs܂B", "G[", MB_OK);
    }
    ::EnableWindow(GetDlgItem(IDC_EDIT_NAME), TRUE);
    ::EnableWindow(GetDlgItem(IDC_EDIT_EMAIL), TRUE);
    ::EnableWindow(GetDlgItem(IDC_EDIT_COMMENT), TRUE);
#ifdef USE_PASSPHRASE
    ::EnableWindow(GetDlgItem(IDC_EDIT_PASSPHRASE), TRUE);
    ::EnableWindow(GetDlgItem(IDC_EDIT_PASSPHRASE2), TRUE);
#endif
    ::EnableWindow(GetDlgItem(IDOK), TRUE);
    ::EnableWindow(GetDlgItem(IDCANCEL), TRUE);
    ::EnableWindow(GetDlgItem(IDC_EDIT_MESSAGE), TRUE);
    ::SendMessage(GetDlgItem(IDC_EDIT_MESSAGE), EM_SETREADONLY, static_cast<WPARAM>(TRUE), 0L);
    return;
  }

  void OnCancel(UINT uNotifyCode, int nID, HWND hWndCtl) {
    EndDialog(IDCANCEL);
  }

};

#endif // !defined(AFX_GENKEYDLG_H__03DDD571_F26C_47A7_A71A_94A6987E5AB3__INCLUDED_)
