// SelectKey.h: CSelectKey NX̃C^[tFCX
//
// Copyright (C) 2006 Kazuyoshi Kakihara
//
// This file is part of JanusLeaf.
//
// JanusLeaf is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SELECTKEY_H__A06828B9_2A81_4476_9A84_3108F96B60DA__INCLUDED_)
#define AFX_SELECTKEY_H__A06828B9_2A81_4476_9A84_3108F96B60DA__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CSelectKey : public CDialogImpl<CSelectKey>  
{
  CGpgParam *pm_gpg;
public:
  enum { IDD = IDD_KEYSELECT };
  CListViewCtrl m_list; // IDC_KEYLIST
  CButton m_radio_pub; // IDC_RADIO_PUB
  CButton m_radio_sym; // IDC_RADIO_SYM
  CButton m_button_keyman; // IDC_BUTTON_KEYMAN
  CButton m_button_selectfile; // IDC_SELECTFILE
  CEdit m_edit_passphrase; // IDC_PASSPHRASE
  CEdit m_edit_passphrase2; // IDC_PASSPHRASE2
  CEdit m_edit_file; // IDC_EDIT_FILE

  // bZ[W}bv
  BEGIN_MSG_MAP_EX(CGenkeyDlg)
    MSG_WM_INITDIALOG(OnInitDialog)
    COMMAND_ID_HANDLER_EX(IDOK, OnOK)
    COMMAND_ID_HANDLER_EX(IDCANCEL, OnCancel)
    COMMAND_ID_HANDLER_EX(IDC_RADIO_PUB, OnPubSelect)
    COMMAND_ID_HANDLER_EX(IDC_RADIO_SYM, OnSymSelect)
    COMMAND_ID_HANDLER_EX(IDC_BUTTON_KEYMAN, OnKeyman)
    COMMAND_ID_HANDLER_EX(IDC_BUTTON_SELECTFILE, OnSelectFile);
  END_MSG_MAP()

  HRESULT loadKeys(VOID) {
    HRESULT hr = S_OK;
    std::vector<std::string> keylist;
    m_list.DeleteAllItems();
    gpg g(pm_gpg->gpgexe.c_str(), pm_gpg->homedir.c_str(), pm_gpg->secring, pm_gpg->pubring);
    if (FAILED(hr = g.listkey(FALSE, keylist, NULL, NULL))) {
      DEBUGOUT(hr);
      return hr;
    }
    int il = 0, icol = 0;
    for (std::vector<std::string>::iterator itr = keylist.begin(); itr != keylist.end(); ++itr) {
      icol = (*itr).find(':');
      std::string struid = (*itr).substr(0, icol);
      std::string strfpr = (*itr).substr(icol + 1);
      if ((il = m_list.InsertItem(il, struid.c_str())) == -1) {
        hr = HRESULT_FROM_WIN32(::GetLastError());
        DEBUGOUT(hr);
        return hr;
      }
      // fingerprint4Ƃɋ؂
      std::string strfprv;
      int ic = 0;
      for (std::string::const_iterator itr = strfpr.begin(); itr != strfpr.end(); ++itr) {
        if ((ic != 0) && (ic % 4 == 0)) {
          strfprv.append(" ");
        }
        strfprv.append(&(*itr), 1);
        ++ic;
      }
      if (!m_list.SetItemText(il, 1, strfprv.c_str())) {
        hr = HRESULT_FROM_WIN32(::GetLastError());
        DEBUGOUT(hr);
        return hr;
      }
    }
    return hr;
  }

  LRESULT OnInitDialog(HWND hWnd, LPARAM lParam) {
    CenterWindow();

    pm_gpg = reinterpret_cast<CGpgParam *>(lParam);
    pm_gpg->recipients.clear();
    pm_gpg->passphrase = "";

    m_list = GetDlgItem(IDC_KEYLIST);
    m_list.SetExtendedListViewStyle(LVS_EX_FULLROWSELECT);
    m_radio_pub = GetDlgItem(IDC_RADIO_PUB);
    m_radio_sym = GetDlgItem(IDC_RADIO_SYM);
    m_button_keyman = GetDlgItem(IDC_BUTTON_KEYMAN);
    m_edit_passphrase = GetDlgItem(IDC_PASSPHRASE);
    m_edit_passphrase2 = GetDlgItem(IDC_PASSPHRASE2);
    m_edit_file = GetDlgItem(IDC_EDIT_FILE);

    m_list.InsertColumn(0, "Name", LVCFMT_LEFT, 200, 0);
    m_list.InsertColumn(1, "Fingerprint", LVCFMT_LEFT, 300, 0);
    m_edit_passphrase.SetLimitText(MAX_PATH);
    m_edit_passphrase.SetLimitText(MAX_PATH);
    m_edit_file.SetLimitText(MAX_PATH);
    m_edit_file.SetWindowText(pm_gpg->filename.c_str());

    loadKeys();

    m_radio_pub.SetCheck(1);
    m_list.EnableWindow(TRUE);
    m_button_keyman.EnableWindow(TRUE);
    m_edit_passphrase.EnableWindow(FALSE);
    m_edit_passphrase2.EnableWindow(FALSE);

    return 0;
  }

  void OnOK(UINT uNotifyCode, int nID, HWND hWndCtl) {
    int i;
    char buff[MAX_PATH + 1];

    if (m_radio_pub.GetCheck()) {
      pm_gpg->fPub = TRUE;
      int ii = -1;
      while (TRUE) {
        ii = m_list.GetNextItem(ii, LVNI_ALL | LVNI_SELECTED);
        if (ii == -1) break;
        m_list.GetItemText(ii, 1, buff, MAX_PATH);
        LPCSTR p = buff;
        LPSTR p1 = buff;
        while (*p) {
          if (*p == ' ') ++p;
          *p1 = *p;
          ++p1;
          ++p;
        }
        *p1 = '\0';
        pm_gpg->recipients.push_back(buff);
      }
    } else {
      pm_gpg->fPub = FALSE;
      i = m_edit_passphrase.GetWindowText(buff, MAX_PATH);
      std::string passphrase = buff;
      i = m_edit_passphrase2.GetWindowText(buff, MAX_PATH);
      std::string passphrase2 = buff;
      if (passphrase != passphrase2) {
        MessageBox("Passphrase Miss Match!", "Error", MB_OK);
        return;
      }
      pm_gpg->passphrase = passphrase;
    }

    i = m_edit_file.GetWindowText(buff, MAX_PATH);
    if (i == 0) {
      MessageBox("Not Specified Output Filename!", "Error", MB_OK);
      return;
    }
    pm_gpg->filename = buff;

    EndDialog(IDOK);
  }

  void OnCancel(UINT uNotifyCode, int nID, HWND hWndCtl) {
    EndDialog(IDCANCEL);
  }

  void OnPubSelect(UINT uNotifyCode, int nID, HWND hWndCtl) {
    m_list.EnableWindow(TRUE);
    m_button_keyman.EnableWindow(TRUE);
    m_edit_passphrase.EnableWindow(FALSE);
    m_edit_passphrase2.EnableWindow(FALSE);
  }

  void OnSymSelect(UINT uNotifyCode, int nID, HWND hWndCtl) {
    m_list.EnableWindow(FALSE);
    m_button_keyman.EnableWindow(FALSE);
    m_edit_passphrase.EnableWindow(TRUE);
    m_edit_passphrase2.EnableWindow(TRUE);
  }

  void OnKeyman(UINT uNotifyCode, int nID, HWND hWndCtl) {
    CManageKey dlg;
    dlg.DoModal();
    loadKeys();
  }

  void OnSelectFile(UINT uNotifyCode, int nID, HWND hWndCtl) {
    CFileDialog dlg(FALSE, _T("gpg"), pm_gpg->filename.empty() ? NULL : pm_gpg->filename.c_str(), OFN_OVERWRITEPROMPT,
                    _T("gpg t@C (*.gpg)\0*.gpg\0ׂẴt@C (*.*)\0*.*\0\0"));
    if (dlg.DoModal() == IDOK) {
      m_edit_file.SetWindowText(dlg.m_szFileName);
    }
  }
};

#endif // !defined(AFX_SELECTKEY_H__A06828B9_2A81_4476_9A84_3108F96B60DA__INCLUDED_)
